<?php

namespace AppBundle\Entity\Billing;

use AppBundle\Entity\Core\File;
use Doctrine\ORM\Mapping as ORM;
use Dunglas\ApiBundle\Annotation\Iri;
use Symfony\Component\Validator\Constraints as Assert;
use AppBundle\Entity\Traits\TimestampableEntity;
use AppBundle\Entity\Traits\CreatorUpdaterEntity;
use Doctrine\Common\Collections\ArrayCollection;
use Symfony\Component\Serializer\Annotation\Groups;


/**
 * Paramètres généraux d'un export Sdd bank
 *
 *
 * @Iri("http://schema.org/Jvs")
 */
#[ORM\Entity(repositoryClass: 'AppBundle\Entity\Billing\Repository\SddBankRepository')]
class SddBank
{
    use TimestampableEntity;
    use CreatorUpdaterEntity;
    /**
     * @var int
     */
    #[ORM\Column(type: 'integer')]
    #[ORM\Id]
    #[ORM\GeneratedValue(strategy: 'AUTO')]
    #[Groups(['sddbank'])]
    private $id;
    /**
     * @var ArrayCollection<Bill>
     */
    #[ORM\OneToMany(targetEntity: 'Bill', mappedBy: 'sddBank', orphanRemoval: true)]
    private $bills;
    /**
     * @var \DateTime
     */
    #[ORM\Column(type: 'date', nullable: true)]
    #[Assert\Date]
    #[Groups(['sddbank'])]
    private $date;
    /**
     * @var File
     */
    #[Assert\Valid]
    #[ORM\OneToOne(targetEntity: 'AppBundle\Entity\Core\File', cascade: ['persist'], fetch: 'EAGER')]
    #[ORM\JoinColumn(nullable: true)]
    #[Groups(['sddbank'])]
    private $file;
    /**
     * @var \DateTime
     */
    #[ORM\Column(type: 'date', nullable: true)]
    #[Assert\Date]
    private $samplingDate;
    /**
     * The constructor
     */
    public function __construct() {
        $this->bills = new ArrayCollection();
    }
    /**
     * Sets id.
     *
     * @param int $id
     *
     * @return $this
     */
    public function setId($id)
    {
        $this->id = $id;

        return $this;
    }
    /**
     * Gets id.
     *
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set date
     *
     * @param \DateTime $date
     *
     * @return Pes
     */
    public function setDate($date)
    {
        $this->date = $date;

        return $this;
    }
    /**
     * Get date
     *
     * @return \DateTime
     */
    public function getDate()
    {
        return $this->date;
    }
    /**
     * Set file
     *
     * @param \AppBundle\Entity\Core\File $file
     *
     * @return Pes
     */
    public function setFile(\AppBundle\Entity\Core\File $file = null)
    {
        $this->file = $file;

        return $this;
    }
    /**
     * Get file
     *
     * @return \AppBundle\Entity\Core\File
     */
    public function getFile()
    {
        return $this->file;
    }
    /**
     * Add bill
     *
     * @param \AppBundle\Entity\Billing\Bill $bill
     *
     * @return Pes
     */
    public function addBill(\AppBundle\Entity\Billing\Bill $bill)
    {
        $this->bills[] = $bill;

        return $this;
    }
    /**
     * Remove bill
     *
     * @param \AppBundle\Entity\Billing\Bill $bill
     */
    public function removeBill(\AppBundle\Entity\Billing\Bill $bill)
    {
        $this->bills->removeElement($bill);
    }
    /**
     * Get bills
     *
     * @return \Doctrine\Common\Collections\Collection
     */
    public function getBills()
    {
        return $this->bills;
    }
    /**
     * Set samplingDate
     *
     * @param \DateTime $samplingDate
     *
     * @return Pes
     */
    public function setSamplingDate($samplingDate)
    {
        $this->samplingDate = $samplingDate;

        return $this;
    }
    /**
     * Get samplingDate
     *
     * @return \DateTime
     */
    public function getSamplingDate()
    {
        return $this->samplingDate;
    }
}
